//***********************************************************
//	Program: FLOAT.C										*
//															*
//	Description: Converts a decimal number to the IEEE		*
//		format required by the PIC16/17.					*
//															*
//	Revision 1.00											*
//															*
//	Copyright (C) Microchip Technology Incorporated 1994	*
//															*
//***********************************************************

#include	<stdlib.h>
#include	<stdio.h>
#include	<conio.h>
#include	<float.h>
#include	<math.h>

// Function prototypes


void main (void)
{
	int		mantissa, temp_e, temp_eb, bias = 128;
	long	temp_f = 0;
    int		i, one = 1, temp_a[32];
	double	input, temp_z, temp_x;

	printf ("\n\n Enter the number of mantissa bits: ");
    scanf  ("%d", &mantissa);
	printf ("\n\n Enter the decimal value: ");
	if (scanf ("%lf", &input) <= 0)
	  {
		printf ("\nCannot have negative number!");
		exit (1);
	  }

	temp_z = log10 (input) / log10 (2);
	temp_e = temp_z;

	  if ((double) temp_e <= temp_z)
	  	  temp_e++; 

	    temp_eb = temp_e + bias;

	temp_x = ldexp (input, ~temp_e+1);

	for (i=0; i<=mantissa; i++)
	  {
		if (temp_x >= ldexp (one, ~i+1))
		  temp_a[i] = 1;
		else
		  temp_a[i] = 0;

		  temp_f = (temp_f << 1) + temp_a[i];
		  temp_x -= ldexp (temp_a[i], ~i+1);
	  }

	  printf ("\n The Exponent is: %xh", temp_eb);
	  printf ("\n The Mantissa has %d bits and is: %lxh", mantissa, temp_f);

	exit (0);            
}